//
//  WallpaperChanger.m
//  Demo2
//
//  Created by 荻原 剛志 on 11/03/15.
//  Copyright 2011. All rights reserved.
//

#import "WallpaperChanger.h"

@implementation WallpaperChanger

- (void)addNewURL:(NSURL *)url // Local Method
{
    NSString *filename = [url lastPathComponent];
    if (filelist == nil) {
        [popup removeAllItems];
        [popup setEnabled:YES];
        filelist = [NSMutableArray array];
    }
    [filelist addObject:url];
    [popup addItemWithTitle:filename];
    [popup selectItemAtIndex:[filelist count] - 1];
    [self selectItem:popup];
}

- (IBAction)addNewImage:(id)sender {
    NSArray *ext = [NSArray arrayWithObjects:@"jpg", @"png", nil];
    NSOpenPanel *opanel = [NSOpenPanel openPanel];
    [opanel setAllowsMultipleSelection:NO];
    [opanel setCanChooseDirectories:NO];
    [opanel setExtensionHidden:NO];
    [opanel setAllowedFileTypes:ext];
    [opanel beginSheetModalForWindow:window completionHandler:
     ^(NSInteger result){
         if (result == NSFileHandlingPanelOKButton) {
             [self addNewURL:[opanel URL]];
         }
     }];
}

- (IBAction)selectItem:(id)sender {
    NSWorkspace *ws = [NSWorkspace sharedWorkspace];
    NSScreen *sc = [NSScreen mainScreen];
    NSInteger idx = [popup indexOfSelectedItem];
    NSURL *url = [filelist objectAtIndex:idx];
    NSDictionary *opt = [ws desktopImageOptionsForScreen:sc];
    if (![ws setDesktopImageURL:url
                      forScreen:sc options:opt error:NULL])
        NSLog(@"Can't Display");
}
@end
